/**
 * This is commercial software, only users who have purchased a valid license
 * and accept to the terms of the License Agreement can install and use this
 * program.
 *
 * Do not edit or add to this file if you wish to upgrade Godomall5 to newer
 * versions in the future.
 *
 * 공용 스크립트 및 프로토타입 정의
 *
 * @copyright ⓒ 2016, NHN godo: Corp.
 * @link http://www.godo.co.kr
 */

/**
 * 자바스크립트 Trim함수
 *
 * @deprecated 자바스크립트 기본 함수 혹은 $.trim() 사용
 * @return string 좌우 공백 제거한 문자열
 */
//String.prototype.trim = function () {
//    return this.replace(/^\s+|\s+$/, '');
//};

/**
 * 자바스크립트 number_format 함수
 *
 * @deprecated numeral로 대체
 * @return string 문자열을 세자리 단위로 쉼표 찍기
 */
//String.prototype.number_format = function()
//{
//    return this.replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,');
//};

// IE9에서 console 객체가 없어 console 객체가 없는 경우 log로 사용하도록 처리
if (!window.console) console = {
    log: function () {
    }
};

// IE8 이하에서 Array.indexOf 지원하지 않는 경우에 대한 대응
if (typeof Array.prototype.indexOf !== 'function') {
    Array.prototype.indexOf = function (ele) {
        return $.inArray(ele, this);
    };
}

// IE8 이하에서 String.trim 지원하지 않는 경우에 대한 대응
if (typeof String.prototype.trim !== 'function') {
    String.prototype.trim = function(){
        return $.trim(this);
    };
}

/**
 * DOM 로드
 */
$(document).ready(function () {
    // IE 9 이하 placeholder 처리
    if (isIE() < 10) {
        $("input, textarea").placeholder();

        $('form').submit(function(e){
            $(this).find("input[placeholder], textarea[placeholder]").each(function(){
                if ($(this).is('[placeholder]') === true) {
                    var _name = this.name;
                    var _placeholder = this.getAttribute('placeholder');
                    var _target = document.getElementsByName(_name)[0];

                    if (_target.value == _placeholder) {
                        _target.value = '';
                    }
                }
            });
        });
    }

    // Ajax 에러 및 처리 기본값 설정
    $.ajaxSetup({
        beforeSend: function (xhr, settings) {
            xhr.url = settings.url;
            xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));
        },
        complete: function () {
            triggerCheckboxUi();
            selectRemodeling();
            gd_checkbox_all();

        },
        error: function (xhr, textStatus, error) {
            if (xhr.status == '404' && error == 'Not Found') {
                console.log('[404 Not Found]\nThe requested URL was not found.');
            }
            else if (xhr.status == '500' && error == 'Internal Server Error' && xhr.responseText != '') {
                console.log(xhr.responseText);
            }
            closeLayer();
            console.log('Ajax Error URL: ' + xhr.url, xhr.responseText);
        }
    });

    // jQuery Validator 기본값 설정
    $.validator.setDefaults({
        onfocusout: false,
        onclick: false,
        onkeyup: false,
        errorPlacement: function (error, element) {
            // do nothing
        },
        invalidHandler: function (form, validator) {
            var errors = validator.numberOfInvalids();
            if (errors) {
                alert(validator.errorList[0].message);
                validator.errorList[0].element.focus();
            }
        },
        submitHandler: function (form) {
            form.submit();
        }
    });

    // jQuery Validator 기본 메시지 설정
    jQuery.extend(jQuery.validator.messages, {
        required: "이 필드는 필수 입력입니다.",
        remote: "이 필드를 수정해주세요.",
        email: "유효한 이메일로 다시 입력해주세요.",
        url: "유효한 URL로 다시 입력해주세요.",
        date: "유효한 날짜로 다시 입력해주세요.",
        dateISO: "유효한 ISO 타입의 날짜로 다시 입력해주세요.",
        number: "숫자만 입력하실 수 있습니다.",
        digits: "숫자만 입력하실 수 있습니다.",
        creditcard: "유효한 신용카드 번호로 다시 입력해주세요.",
        equalTo: "동일한 값을 입력해주세요.",
        accept: "Please enter a value with a valid extension.",
        maxlength: jQuery.validator.format("최대 {0}자까지 입력하실 수 있습니다."),
        minlength: jQuery.validator.format("최소 {0}자부터 입력하실 수 있습니다."),
        rangelength: jQuery.validator.format("{0}자에서 {1}까지 입력가능합니다."),
        range: jQuery.validator.format("{0}와 {1}사이의 숫자를 입력해주세요."),
        max: jQuery.validator.format("Please enter a value less than or equal to {0}."),
        min: jQuery.validator.format("Please enter a value greater than or equal to {0}.")
    });

    //검색어
    $("#frmSearchTop").validate({
        submitHandler: function (form) {
            if ($("#frmSearchTop input[name='adUrl']").val() && $("#frmSearchTop input[name='keyword']").val() == '') document.location.href = $("#frmSearchTop input[name='adUrl']").val();
            else form.submit();
        },
        rules: {
            keyword: {
                required: function () {

                    if ($("#frmSearchTop input[name='adUrl']").val()) {
                        return false;
                    }
                    else {
                        return true;
                    }
                }
            }
        },
        messages: {
            keyword: {
                required: '검색어를 입력하세요.'
            }
        }
    });


    // 체크박스 전체 선택 이벤트
    gd_checkbox_all();

    // 체크박스 선택 시 라벨 클래스Add/Remove
    if ($(':checkbox.checkbox').length > 0) {
        $(':checkbox.checkbox').click(function (e) {
            var $target = $(e.target);
            var $label = $target.closest('p').find('label');
            if ($target.prop('checked')) {
                $label.addClass('on');
            } else {
                $label.removeClass('on');
            }
        });
    }

    if ($('button.btn-prev').length > 0) {
        $('button.btn-prev').click(function (e) {
            e.preventDefault();
            history.go(-1);
        });
    }

    // Numeral 언어 정의
    // 랭귀지 폴더에서 스크립트 호출해서 로드 시켜야 함
    //numeral.language('fr', {
    //    delimiters: {
    //        thousands: ' ',
    //        decimal: ','
    //    },
    //    abbreviations: {
    //        thousand: 'k',
    //        million: 'm',
    //        billion: 'b',
    //        trillion: 't'
    //    },
    //    ordinal : function (number) {
    //        return number === 1 ? 'er' : 'ème';
    //    },
    //    currency: {
    //        symbol: '€'
    //    }
    //});
    //numeral.language('fr');


    gd_menu_over();

    // 복사 기능
    // https://github.com/zeroclipboard/zeroclipboard/blob/master/docs/api/ZeroClipboard.md
    if ($('.gd_clipboard').length) {
        if (navigator.userAgent.match(/MSIE 8/) !== null) {
            $('.gd_clipboard').each(function () {
                $(this).click(function () {
                    alert("주소를 드래그 해서 복사해주세요");
                    return false;
                });
            });
        } else {
            var clipboard = new Clipboard('.gd_clipboard');
            clipboard.on('success', function (e) {
                var title = $(e.trigger).attr('title') == undefined ? '' : $(e.trigger).attr('title');
                alert('[' + title + '] 정보를 클립보드에 복사했습니다.\nCtrl+V를 이용해서 사용하세요.');
                e.clearSelection();
            });
            clipboard.on('error', function (e) {
                console.error('Action:', e.action);
                console.error('Trigger:', e.trigger);
            });
        }
    }

    $(document).on('click', '.btn-alert-login', function (e) {
        alert('로그인하셔야 본 서비스를 이용하실 수 있습니다.');
        document.location.href = "../member/login.php";
        return false;
    });

    $('#ghostDepositorBanner').css('cursor', 'pointer').click(function () {
        var url = '/service/popup_ghost_depositor.php';
        var win = popup({
            url: url
            , target: 'ghostDepositorPopup'
            , width: 570
            , height: 560
            , resizable: 'no'
            , scrollbars: 'no'
        });
        win.focus();
        return win;
    });

    // 마이페이지 1:1, 상품 문의 및 후기(iframe) 포커스 설정
    var ifrmScroll = 0;
    $('iframe[name=ifrmMyPage]').load(function () {
        var ifrmURL = $(this).get(0).contentWindow.location.href;

        // 목록에서는 포커스 유지, 목록 외 페이지 포커스 상단
        if (ifrmURL.indexOf('/board/list.php') == -1) {
            $('html, body').scrollTop(0);
        } else {
            $('html, body').scrollTop(ifrmScroll);
        }

        $(this).contents().find('.board-list td a, .list li a').click(function () {
            ifrmScroll = $(document).scrollTop();
        });

        // 글 작성, 수정, 삭제 및 페이징, 목록 버튼 클릭시 포커스 상단
        $(this).contents().find('ul.pagination li, .boadview-reply, .boardview-list, .boarddwrite-save, .boardview-del').click(function () {
            ifrmScroll = 0;
        });
    });


    // 최근 검색어 포커스
    $('#frmSearchTop input[name="keyword"]').focus(function(){
        if($("input[name=recentCount]").val() > 0) {
            $('.search-area').removeClass('dn');
        }
    }).blur(function(){
        $('body').click(function(e){
            if (!$('.search-area').has(e.target).length && e.target.name != 'keyword') {
                $('.search-area').addClass('dn');
            }
        });
    });

    // 최근 검색어 삭제
    $('.js-recent-keyword-delete').click(function(e){
        e.stopPropagation();
        $self = $(this);
        $.post('../goods/goods_ps.php', {
            'mode': 'delete_recent_keyword',
            'keyword': $(this).data('recent-keyword')
        }, function (data, status) {
            // 값이 없는 경우 성공
            if (status == 'success' && data == '') {
                if ($self.closest('ul').find('li').not('.li-tit').length == 1) {
                    $self.closest('li').remove();
                    $('.js-recent-all-delete').remove();
                    $('.recent-list').append('<li class="no-data">최근 검색어가 없습니다.</li>');
                } else {
                    $self.closest('li').remove();
                }
            } else {
                console.log('request fail. ajax status (' + status + ')');
            }
        });
    });

    // 최근 검색어 전체 삭제
    $('.js-recent-all-delete').click(function(e){
        e.stopPropagation();
        $self = $(this);
        $.post('../goods/goods_ps.php', {
            'mode': 'delete_recent_all_keyword'
        }, function (data, status) {
            // 값이 없는 경우 성공
            if (status == 'success' && data == '') {
                $self.closest('ul').find('li').not('.li-tit').remove()
                $('.js-recent-all-delete').remove();
                $('.recent-list').append('<li class="no-data">최근 검색어가 없습니다.</li>');
            } else {
                console.log('request fail. ajax status (' + status + ')');
            }
        });
    });
});

/*
 카테고리/브랜드 카테고리 마우스 오버
 */
function gd_menu_over() {

    $(document).on('mouseenter mouseleave', 'img.gd_menu_over', function (event) {
        $(this).attr({
            src: $(this).attr('data-other-src')
            , 'data-other-src': $(this).attr('src')
        });

    });

    $(document).on('mouseenter', 'span.gd_menu_over', function (event) {
        var width = $(this).closest("strong").width();
        var height = $(this).closest("strong").height() - 7;
        $(this).html("<img src='" + $(this).data('other-src') + "' style='max-width:" + width + "px;max-height:" + height + "px'>");

    });

    $(document).on('mouseleave', 'span.gd_menu_over', function (event) {
         $(this).html($(this).data('other-text'));
    });
}


/*
 체크박스 전체 선택
 */
function gd_checkbox_all() {

    // 체크박스 전체 선택 이벤트
    if ($(':checkbox.gd_checkbox_all').length > 0) {
        // 이벤트 중복 실행을 막아준다.
        $(':checkbox.gd_checkbox_all').off('click');
        $(':checkbox.gd_checkbox_all').click(function (e) {
            var $target = $(e.target);
            var targetName = $target.data('target-name');
            var targetId = $target.data('target-id');
            var targetFormName = $target.data('target-form');
            if (typeof targetFormName == 'undefined') targetFormName = "";
            if (_.isUndefined(targetId)) {
                $(targetFormName + ' :checkbox[name="' + targetName + '"]').prop('checked', !$target.prop('checked')).trigger('click');
            } else {
                $(targetFormName + ' :checkbox[id*="' + targetId + '"]').prop('checked', !$target.prop('checked')).trigger('click');
            }
        });
    }
}

/**
 * 동적 스크립트 바인딩 (스크립트 로딩 후 메서드 실행되도록 처리)
 *
 * @author Jong-tae Ahn
 * @param number
 * @param places
 * @param symbol
 * @param thousand
 * @param decimal
 * @returns {string}
 */
function add_script(url, callback) {
    var done = false; // 스크립트 로딩 여부
    var head = document.getElementsByTagName("head")[0] || document.documentElement;
    var script = document.createElement("script");

    //script.charset = 'UTF-8';
    script.src = url;
    script.onload = script.onreadystatechange = function () {
        if (!done && (!this.readyState || this.readyState === "loaded" || this.readyState === "complete")) {
            done = true;
            callback();

            // IE에서 메모리 누수 방지를 위한 처리
            script.onload = script.onreadystatechange = null;
            if (head && script.parentNode) {
                head.removeChild(script);
            }
        }
    };

    // Use insertBefore instead of appendChild  to circumvent an IE6 bug.
    // This arises when a base node is used (#2709 and #4378).
    head.insertBefore(script, head.firstChild);
}


/**
 * 테스트 진행중
 *
 * @author Jong-tae Ahn
 * @param number
 * @param places
 * @param symbol
 * @param thousand
 * @param decimal
 * @returns {string}
 */
function money_format(number, places, symbol, thousand, decimal) {
    number = number || 0;
    places = !isNaN(places = Math.abs(places)) ? places : 2;
    symbol = symbol !== undefined ? symbol : "$";
    thousand = thousand || ",";
    decimal = decimal || ".";
    var negative = number < 0 ? "-" : "",
        i = parseInt(number = Math.abs(+number || 0).toFixed(places), 10) + "",
        j = (j = i.length) > 3 ? j % 3 : 0;
    return symbol + negative + (j ? i.substr(0, j) + thousand : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousand) + (places ? decimal + Math.abs(number - i).toFixed(places).slice(2) : "");
}

/**
 * 메일 도메인 선택
 */
function select_email_domain(name,select) {
    if (typeof select === 'undefined') {
        select = 'emailDomain';
    }
    var $email = $(':text[name=' + name + ']');
    var $emailDomain = $('select[id='+select+']');
    $emailDomain.on('change', function (e) {
        var emailValue = $email.val();
        var indexOf = emailValue.indexOf('@');
        if (indexOf == -1) {
            $email.val(emailValue + '@' + $emailDomain.val());
            $email.trigger('focusout');
        } else {
            if ($emailDomain.val() === 'self') {
                $email.val(emailValue.substring(0, indexOf + 1));
                $email.focus();
            } else {
                $email.val(emailValue.substring(0, indexOf + 1) + $emailDomain.val());
                $email.trigger('focusout');
            }
        }
    });
}

/**
 * 팝업창 Cookie 컨트롤
 * @param string name 팝업창 이름 (코드_창종류)
 * @param object elemnt elemnt
 * @return
 */
function popup_cookie(name, elemnt) {
    if (elemnt.checked === true) {
        $.cookie(name, 'true', {path: '/', expires: 1});
        var popupKind = name.split('_');
        if (popupKind[1] == 'window') {
            setTimeout('self.close()');
        } else {
            setTimeout("$('#" + name + "').hide()");
        }
    } else {
        $.cookie(name, null);
    }
    return;
}

/**
 * 윈도우팝업 호출
 * @param array options 창정보
 * @return object Window 개체
 */
function popup(options) {
    if (!options.width) options.width = 500;
    if (!options.height) options.height = 415;
    var status = new Array();
    $.each(options, function (i, v) {
        if ($.inArray(i, ['url', 'target']) == '-1') {
            status.push(i + '=' + v);
        }
    });
    var status = status.join(',');
    var win = window.open(options.url, options.target, status);
    return win;
}

/**
 * 통신판매사업자 상세조회창
 * @param string businessNo 사업자 번호
 * @return
 */
function popup_bizInfo(businessNo) {
    var url = 'http://www.ftc.go.kr/info/bizinfo/communicationViewPopup.jsp?wrkr_no=' + businessNo;
    var win = popup({
        url: url
        , target: 'communicationViewPopup'
        , width: 750
        , height: 700
        , resizable: 'no'
        , scrollbars: 'no'
    });
    win.focus();
    return win;
}

/**
 * 메일 보내기
 * @param string toMail 메일대상자
 * @param string subject 메일 제목
 * @return
 */
function popup_email(toMail, subject) {
    if (typeof toMail === 'undefined') {
        return;
    }

    if (typeof subject === 'undefined') {
        subject = '문의드립니다';
    }

    location.href = 'mailto:' + toMail + '?subject=' + subject;
}

/**
 * 도로명 주소 찾기 (팝업)
 *
 * @author artherot
 * @param string zoneCodeID zonecode input ID
 * @param string addrID address input ID
 * @param string zipCodeID zipcode input ID
 */
function postcode_search(zoneCodeID, addrID, zipCodeID) {
    var win = popup({
        url: '../share/postcode_search.php?zoneCodeID=' + zoneCodeID + '&addrID=' + addrID + '&zipCodeID=' + zipCodeID,
        target: 'postcode',
        width: 500,
        height: 450,
        resizable: 'yes',
        scrollbars: 'yes'
    });
    win.focus();
    return win;
}

/**
 * PG 관련 영수증 보기
 *
 * @author artherot
 * @param string modeStr 카드, 현금영수증 종류 (card, cash)
 * @param string orderNo 주문 번호
 */
function pg_receipt_view(modeStr, orderNo) {
    // 사이즈를 미리 설정 - 자동으로 창이 커지지 않아 미리 설정함
    var preWidth = 430;
    var preHeight = 700;

    // 미리 팝업창을 띄우기
    var prePopupData = {
        'url': 'about:blank',
        'target': 'show_receipt',
        'width': preWidth,
        'height': preHeight
    };
    var show_receipt = popup(prePopupData);

    // 각 PG별 영수증 팝업창
    $.post('../share/show_receipt.php', {
        mode: modeStr,
        orderNo: orderNo
    }, function (data) {
        var infoData = data;
        if (typeof infoData['error'] == 'undefined') {
            popup(infoData);
        }
        else {
            alert(infoData['error']);
            show_receipt.close();
        }
    }, 'json');
}

/**
 * 쿼리스트링값 찾기
 * @param query
 * @param variable
 * @returns {string}
 */
function getQueryVariable(query, variable) {
    var vars = query.split('&');
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split('=');
        if (decodeURIComponent(pair[0]) == variable) {
            return decodeURIComponent(pair[1]);
        }
    }
    console.log('Query variable %s not found', variable);
}

/**
 * 스트링 치환 메소드
 * @returns {String}
 */
String.prototype.format = function () {
    var formatted = this;
    for (var i = 0; i < arguments.length; i++) {
        formatted = formatted.replace("{" + i + "}", arguments[i]);
    }
    return formatted;
};

function resize_frame(obj) {
    var iframeHeight = (obj).contentWindow.document.body.clientHeight;
    (obj).height = iframeHeight + 80;
}

/**
 * 회원다운로드 쿠폰 링크 다운 받기
 *
 * @param couponNo
 */
function couponLinkDown(couponNo) {
    var params = {
        mode: "couponDownLink",
        couponCode: couponNo
    };
    $.ajax({
        method: "POST",
        cache: false,
        url: "/mypage/coupon_link_down.php",
        data: params,
        success: function (data) {
            result = JSON.parse(data);
            alert(result['msg']);
        },
        error: function (data) {
            alert(result['msg']);
        }
    });
}

/**
 * 비회원 개인정보 수집항목 동의 링크
 */
function redirectCollectionAgree() {
    window.open('/service/private.php');
}


var gdAjaxUpload = {
    upload : function(data) {
        var formData = new FormData();
        for (var k in data.params){
            if (data.params.hasOwnProperty(k)) {
                formData.append(k, data.params[k]);
            }
        }
        if(data.onbeforeunload){
            window.onbeforeunload = data.onbeforeunload;
            data.formObj.on("submit", function () {
                window.onbeforeunload = null;
            });
        }

        if(data.formObj.find('[name=uploadType][value=ajax]').length < 1) {
            data.formObj.append('<input type="hidden"  name="uploadType" value="ajax" >');
        }
        var index = data.thisObj.closest('form').find('input:file').index(data.thisObj);
        formData.append('uploadFile', data.thisObj[0].files[0]);

        $.ajax({
            url: data.actionUrl,
            type: 'POST',
            data: formData,
            async: false,
            cache: false,
            contentType: false,
            processData: false,
            dataType: 'json',
            success: function (returnData) {
                returnData['index'] = index;
                if(returnData.result == 'ok') {
                    if ($('input[name="uploadFileNm[' + index + ']"]').length == 0) {
                        data.formObj.append("<input type='hidden' name='uploadFileNm[" + index + "]' value='" + returnData.uploadFileNm + "'>");
                        data.formObj.append("<input type='hidden' name='saveFileNm[" + index + "]' value='" + returnData.saveFileNm + "'>");
                    }
                    else {
                        $("input[name='uploadFileNm[" + index + "]']").val(returnData.uploadFileNm);
                        $("input[name='saveFileNm[" + index + "]']").val(returnData.saveFileNm);
                    }
                    if(typeof data.successAfter == 'function') {
                        data.successAfter(returnData);
                    }
                }
                else if(returnData.result == 'cancel'){
                    if ($("input[name='uploadFileNm[" + index + "]']").length >0) {
                        $("input[name='uploadFileNm[" + index + "]']").remove();
                        $("input[name='saveFileNm[" + index + "]']").remove();
                    }
                }
                else {
                    gdAjaxUpload.isSuccess = false;
                    $('label[for=attach'+(index+1)+'] .text').val('');  //파일시스템 텍스트 빈값 처리
                    alert(returnData.errorMsg);
                    if(typeof data.failAfter == 'function') {
                        data.failAfter(returnData);
                    }
                }
            }
        });
    }
}

/*** 스토리지 지원 여부 ***/
function supports_html5_storage() {
    try {
        return 'localStorage' in window && window['localStorage'] !== null;
    } catch (e) {
        return false;
    }
}

/*** 세션 스토리지 저장 ***/
function saveSession(control_key, control_value) {
    if (!supports_html5_storage()) {
        createCookie(control_key, control_value, 7);
    } else {
        sessionStorage[control_key] = control_value;
    }
};

/*** 세션 스토리지 로드 ***/
function loadSession(control_key) {
    var control_value;
    if (!supports_html5_storage()) {
        control_value = readCookie(control_key);
    } else {
        control_value = sessionStorage[control_key];
    }
    return control_value;
};

/*** 로컬 스토리지 저장 ***/
function saveVal(control_key, control_value) {
    if (!supports_html5_storage()) {
        createCookie(control_key, control_value, 7);
    } else {
        localStorage.setItem(control_key, control_value);
    }
};

/*** 로컬 스토리지 로드 ***/
function loadVal(control_key) {
    var control_value;
    if (!supports_html5_storage()) {
        control_value = readCookie(control_key);
    } else {
        control_value = localStorage.getItem(control_key);
    }
    return control_value;
};

/*** IE 버전 체크 ***/
function isIE () {
    var nav = navigator.userAgent.toLowerCase();
    if (nav.indexOf('msie') != -1) {
        return parseInt(nav.split('msie')[1]);
    } else {
        return false;
    }
}
